# -*- Mode: rpm-spec -*-
%define name zsh
%define version 4.0.4
%define rversion 4.0.4
%define dversion %{rversion}
%define release 6mdk
%define url ftp://ftp.zsh.org/pub/
%define full_preversion %{rversion}

Summary: A shell with lots of features.
Name: %{name}
Version: %{version}
Release: %{release}
Url: http://www.zsh.org
Source0: %{url}/%{name}-%{full_preversion}.tar.bz2
Source1: %{url}/%{name}-%{dversion}-doc.tar.bz2
Source2: zcfg-mdk.tar.bz2
Source3: http://zsh.sunsite.dk/Guide/zshguide.tar.bz2
Patch1: zsh-3.1.6-dev-22-path.patch.bz2
Patch2: zsh-4.0.1-pre-3-rpmnewopt.patch.bz2
Patch3: zsh-4.0.4-add-mandrake-dir.patch.bz2
Patch4: zsh-4.0.4-urpmi-completion.patch.bz2
Patch5: zsh-4.0.4-bash-functions-cvs.patch.bz2
License: GPL
Group: Shells
Prefix: %{_prefix}
Prereq: fileutils grep
Epoch: 1
# Available in our contrib.
BuildRequires: gcc libtermcap2-devel texinfo yodl
BuildRoot: %{_tmppath}/%{name}-buildroot

%description
Zsh is a UNIX command interpreter (shell) usable as an
interactive login shell and as a shell script command
processor. Of the standard shells, zsh most closely resembles
ksh but includes many enhancements. Zsh has command-line editing,
built-in spelling correction, programmable command completion,
shell functions (with autoloading), a history mechanism, and a
lots of other features

Install the zsh package if you'd like to try out a different shell.

%package doc
Summary: The doc package of zsh
Group: Shells

%description doc
Zsh is a UNIX command interpreter (shell) usable as an
interactive login shell and as a shell script command
processor. Of the standard shells, zsh most closely resembles
ksh but includes many enhancements. Zsh has command-line editing,
built-in spelling correction, programmable command completion,
shell functions (with autoloading), a history mechanism, and a
lots of other features

This package include doc guid examples and manual for zsh.

%prep
%setup -q -a 2 -a 1 -n %{name}-%{full_preversion}
mv %{name}-%{dversion}/Doc/* Doc/
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# remove temporary files
find|grep '~$'|xargs rm -f

%build
%ifnarch sparc
%configure --enable-etcdir=%{_sysconfdir} --enable-function-subdirs --disable-debug
%else
%configure --enable-etcdir=%{_sysconfdir} --enable-function-subdirs --disable-lfs
%endif

make all

%install
rm -rf $RPM_BUILD_ROOT

make install-strip DESTDIR=%{buildroot}
make install.info DESTDIR=%{buildroot}

# copy Mandrake Configuration files.
mkdir -p $RPM_BUILD_ROOT/{bin,etc}
cp -a zcfg/etc/z* $RPM_BUILD_ROOT%{_sysconfdir}
cp -a zcfg/share/zshrc_default %{buildroot}%{_datadir}/zsh/%{full_preversion}/zshrc_default

# Backward compatibilie should be removed in the others times.
pushd $RPM_BUILD_ROOT/bin && {
    mv ..%{_bindir}/zsh ./zsh
} && popd

# Copy documentation.
rm -rf docroot
mkdir -p docroot/{Info_html,Examples,Documentation}/

cp -a README docroot/
cp -a Functions/Misc/* Misc/* Util/* docroot/Examples/
cp -a INSTALL ChangeLog* docroot/Documentation 
cp -a StartupFiles docroot/
cp -a Etc/* docroot/Documentation
mv docroot/Documentation/NEWS docroot/
cp -a Doc/*html docroot/Info_html/

mkdir -p docroot/Zsh_Guide
bzcat %{SOURCE3}|tar xf - -C docroot/Zsh_Guide
mv docroot/Zsh_Guide/zshguide/*html docroot/Zsh_Guide/
rmdir docroot/Zsh_Guide/zshguide

find docroot/ -type f|xargs perl -p -i -e 's|^#!%{prefix}/local/bin/zsh|#!%{_bindir}/zsh|'
find docroot/ -type f|xargs perl -p -i -e 's|^#!%{prefix}/local/bin/perl|#!%{_bindir}/perl|'

rm -f docroot/StartupFiles/.distfiles
rm -f docroot/Examples/{Makefile*,*.yo}
rm -f docroot/Documentation/{Makefile*,*.yo}
mv docroot/Examples/compctl-examples docroot/StartupFiles

find docroot/ -name 'Makefile*' -o -name '.yo'|xargs rm -f

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ ! -f %{_sysconfdir}/shells ]; then
	echo "/bin/zsh" > %{_sysconfdir}/shells
else
	grep '^/bin/zsh' %{_sysconfdir}/shells > /dev/null || echo "/bin/zsh" >> /etc/shells
fi
%_install_info %{name}.info

%postun
if [ ! -x /bin/zsh ]; then
	grep -v '^/bin/zsh$' %{_sysconfdir}/shells | grep -v '^/bin/zsh$'> /etc/shells.rpm
	mv %{_sysconfdir}/shells.rpm /etc/shells
fi
%_remove_install_info %{name}.info

%files
%defattr(-,root,root,0755)
%doc docroot/README docroot/NEWS
%config(noreplace) %{_sysconfdir}/z*
/bin/%{name}
%{_mandir}/man1/*.1*
%{_infodir}/*.info*
%dir %{_datadir}/zsh
%dir %{_datadir}/zsh/%{full_preversion}/
%{_datadir}/zsh/%{full_preversion}/functions
%{_datadir}/zsh/%{full_preversion}/zshrc_default
%{_libdir}/zsh/%{full_preversion}/
%{_datadir}/zsh/site-functions/

%files doc
%defattr(-,root,root)
%doc docroot/Documentation/ docroot/Examples/ docroot/Info_html/ docroot/StartupFiles/
%doc docroot/Zsh_Guide

%changelog
* Tue Jan 22 2002 Stefan van der Eijk <stefan@eijk.nu> 4.0.4-6mdk
- BuildRequires

* Mon Jan 14 2002 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.4-5mdk
- Upgrade urpmi completion (Andrej).

* Mon Dec 10 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.4-4mdk
- Add bash-functions from cvs.
- Add %_datadir/zsh also as %dir.

* Tue Nov 20 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.4-3mdk
- Make /usr/share/zsh/version as %dir.

* Thu Nov 15 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.4-2mdk
- Upgrade zshguide.
- Add urpmi completion from Andrej.

* Fri Nov  9 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.4-1mdk
- s|Epoch|Serial|;
- 4.0.4.

* Sun Jul 01 2001 Geoffrey Lee <snailtalk@mandrakesoft.com> 4.0.2-2mdk
- s/Copyright/License/;
- Rebuild to get /bin/zsh back, is it just a weird problem which I have 
  on my own machine?

* Wed Jun 27 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.2-1mdk
- 4.0.2.

* Tue Jun  5 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.1-1mdk
- Make the Alt-Backspace bash alike with WORDCHARS set to ''.
- 4.0.1 final.

* Sun May 27 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.1-0.4mdk
- upgrade to 052701 cvs.

* Wed May 23 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.1-0.3mdk
- Remove most of the mdk-system-wide options and put it in a
  distribution files sourced if not ~/.zshrc is present.
- 4.0.1-pre-5.

* Mon May 14 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.1-0.2mdk
- 4.0.1-pre-4.

* Mon Apr 23 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.0.1-0.1mdk
- 4.0.1-pre-3.
- Redo the configuration.

* Fri Mar  9 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.9-6mdk
- Source /etc/profile.d/ files.

* Thu Mar  8 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.9-5mdk
- Don't build help since it look it doen't works.

* Sat Aug 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.9-4mdk
- Set some %config file to (noreplace).
- Make -A to complete spec file for _rpm.

* Thu Jul 20 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.9-3mdk
- Get /usr/share/man also in the completion for perl manpages.
- BM.

* Wed Jul  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.9-2mdk
- Fix buildroot hardcoded in binary.

* Wed Jun 21 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.9-1mdk
- Use makeinstall macros (not easy this one :\).
- 3.1.9.

* Mon Jun  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.8-1mdk
- 3.1.8.

* Sun May 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev22-3mdk
- Fix path (%{prefix}/ucb -> %{_bindir}/X11)
- Fix keys (home-end-suppr-delete) directly in the zsh binary.

* Sun Apr 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev22-2mdk
- Remove doble .so in %{_libdir}/zsh/*.

* Thu Apr 13 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev22-1mdk
- 3.1.6dev22.

* Fri Mar 31 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev20-3mdk
- Fix completion of rpm with -qp*.

* Mon Mar 27 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev20-2mdk
- Upgrade zshguide.

* Sat Mar 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev20-1mdk
- 3.1.6-dev20

* Wed Mar 22 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev19-3mdk
- Move global configuration here.
- Adjust groups.

* Tue Feb 22 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev19-2mdk
- Add new zshguide from pws.
- Separate the doc to the doc package

* Sun Feb 20 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev19-1mdk
- Clean Up spec (thanks specs-helper).
- Remove all our patchs (now all is commited to upstream main).
- 3.1.6dev19.

* Fri Feb 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev18-3mdk
- Recompile with glibc2.1.3 (first one).

* Thu Feb 17 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev18-2mdk
- Add --freshen completion.

* Tue Feb 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev18-1mdk
- Fix descriptions and summary.
- 3.1.6dev18.

* Thu Feb 10 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev17-2mdk
- Remove Makefile in %doc.
- BuildRequires: autoconf tetex.
- Lot of modications in the default config as suggested by Bart
  Schaefer <schaefer@zsh.org>.
- 3.1.6dev17.

* Mon Jan 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev16-1mdk
- dev16.
- Redo the tar_archive patchs.

* Tue Jan 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev15-1mdk
- dev15.
- Fix doc generation with dev15.
- remove META-FAQ.
- disable lfs on sparc.

* Thu Jan  6 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6dev14-1mdk
- dev14 (note the name change).

* Mon Jan  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.6pws13-3mdk
- Remove temporary files.

* Fri Dec 31 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 3.1.6pws13 (mainly bug fixes).
- fix %post.
- fix rpm completion

* Thu Dec 09 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 3.1.6pws11 (mainly bug fixes).

* Tue Dec  7 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Add run-help and perl-build the documentation.

* Tue Nov 30 1999 Francis Galiegue <francis@mandrakesoft.com>

- Completion machine patch - we use GNU make and GNU tar
- Small fix to %post script

* Tue Nov 30 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 3.1.6pws10
- Fix zprofile.
- Clean-up Franciseries.
- Clean-up specs.

* Mon Nov 29 1999 Francis Galiegue <francis@mandrakesoft.com>
- Grrr... Rebuilt on kenobi, toy ain't a cooker

* Mon Nov 29 1999 Francis Galiegue <francis@mandrakesoft.com>

- Completion system now handles bzip2'ed manpages and tarballs
- Some cool options

* Wed Nov 10 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Add zshguide.txt to documentation.

* Thu Oct 07 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Fix bug in %{_sysconfdir}/zsh use USERNAME instead of USER.
- Improve %{_sysconfdir}/z* to source the /etc/profile.d/ files.

* Mon Oct 04 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- 3.1.6-pws6
- Fix bad link.
- Fix bad manpages.

* Tue Aug 17 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- fix typo in examples directory name

* Sun Aug  8 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Copy documentation (yes a lot).
- Remove the completion machine and put them in [[ {etc,root}(skel|files) ]] package.

* Sat Aug  7 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- By defaut we launch the completion machine.
- Put zsh in %{_bindir}/
- Rewrite of Spec file for this new major version.

# end of file
